diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSpikes.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSpikes.java
new file mode 100644
index 000000000..4c1b2bbf0
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSpikes.java
@@ -0,0 +1,30 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicSpikes;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericSpikes<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public @NotNull StaticBlockModel spikes;
+    public BlockModelGenericSpikes(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/spikes_base"));
+        this.spikes = BlockModelDispatcher.loadDataModel("minecraft:block/spikes").asModel();
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        boolean didRender = super.renderAttached(tessellator, worldSource, tilePos, cullFaces, overrideTexture);
+        if (BlockLogicSpikes.isSpikesUp(worldSource.getBlockData(tilePos))) {
+            didRender |= this.spikes.renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+        }
+        return didRender;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericStairs.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericStairs.java
new file mode 100644
index 000000000..5c8e32660
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericStairs.java
@@ -0,0 +1,36 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericStairs<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public BlockModelGenericStairs(@NotNull Block<T> block, @NotNull StaticBlockModel staticModel) {
+        super(block, staticModel);
+    }
+
+    public BlockModelGenericStairs(@NotNull Block<T> block, @NotNull BlockModelData staticModel) {
+        super(block, staticModel);
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        int meta = worldSource.getBlockData(tilePos);
+        int hRotation = meta & 0b0011;
+        int vRotation = (meta & 0b1000) >> 3;
+        int yRot = switch (hRotation) {
+            case 0 -> 0;
+            case 1 -> 2;
+            case 2 -> 3;
+            default -> 1;
+        };
+        return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, vRotation * 2, yRot, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericStairsPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericStairsPainted.java
new file mode 100644
index 000000000..0c707829b
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericStairsPainted.java
@@ -0,0 +1,29 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericStairsPainted<T extends BlockLogic> extends BlockModelGenericStairs<T> {
+    public final @NotNull StaticBlockModel[] models = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public BlockModelGenericStairsPainted(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/stairs/planks/" + DyeColor.WHITE.colorID));
+        for (DyeColor color : DyeColor.blockOrderedColors()) {
+            this.models[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/stairs/planks/" + color.colorID).asModel();
+        }
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return this.models[(data >> 4) & DyeColor.MASK_COLOR];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericTorch.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericTorch.java
new file mode 100644
index 000000000..2f4a1de17
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericTorch.java
@@ -0,0 +1,32 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicTorch;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericTorch<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel wallTorch;
+    public BlockModelGenericTorch(@NotNull Block<T> block, @NotNull String baseKey) {
+        super(block, BlockModelDispatcher.loadDataModel(baseKey));
+        this.wallTorch = BlockModelDispatcher.loadDataModel(baseKey + "_wall").asModel();
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        return switch (worldSource.getBlockData(tilePos) & BlockLogicTorch.MASK_DIRECTION) {
+            case BlockLogicTorch.SIDE_WEST -> this.wallTorch.renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            case BlockLogicTorch.SIDE_EAST -> this.wallTorch.renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            case BlockLogicTorch.SIDE_NORTH -> this.wallTorch.renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            case BlockLogicTorch.SIDE_SOUTH -> this.wallTorch.renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            default -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+        };
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericTrapdoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericTrapdoor.java
new file mode 100644
index 000000000..f7d8613fd
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericTrapdoor.java
@@ -0,0 +1,41 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicTrapDoor;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericTrapdoor<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel open;
+    public final @NotNull StaticBlockModel top;
+    public BlockModelGenericTrapdoor(@NotNull Block<T> block, @NotNull String basekey) {
+        super(block, BlockModelDispatcher.loadDataModel(basekey + "/bottom"));
+        this.open = BlockModelDispatcher.loadDataModel(basekey + "/open").asModel();
+        this.top = BlockModelDispatcher.loadDataModel(basekey + "/top").asModel();
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        int rotation = worldSource.getBlockData(tilePos) & BlockLogicTrapDoor.MASK_DIRECTION;
+        return switch (rotation & 0b11) {
+            case 1 -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            case 2 -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            case 3 -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            default -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+        };
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        if ((data & BlockLogicTrapDoor.MASK_OPEN) != 0) return this.open;
+        if ((data & BlockLogicTrapDoor.MASK_UPPER_HALF) != 0) return this.top;
+        return this.staticModel;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericTrapdoorPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericTrapdoorPainted.java
new file mode 100644
index 000000000..ef1d41a03
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericTrapdoorPainted.java
@@ -0,0 +1,47 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicTrapDoor;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericTrapdoorPainted<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel[] bottom = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public final @NotNull StaticBlockModel[] open = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public final @NotNull StaticBlockModel[] top = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public BlockModelGenericTrapdoorPainted(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/trapdoor/planks/white/bottom"));
+        for (DyeColor color : DyeColor.blockOrderedColors()) {
+            this.bottom[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/trapdoor/planks/" + color.colorID + "/bottom").asModel();
+            this.open[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/trapdoor/planks/" + color.colorID + "/open").asModel();
+            this.top[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/trapdoor/planks/" + color.colorID + "/top").asModel();
+        }
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        int rotation = worldSource.getBlockData(tilePos) & BlockLogicTrapDoor.MASK_DIRECTION;
+        return switch (rotation & 0b11) {
+            case 1 -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            case 2 -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            case 3 -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            default -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+        };
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        int color = (data >> 4) & DyeColor.MASK_COLOR;
+        if ((data & BlockLogicTrapDoor.MASK_OPEN) != 0) return this.open[color];
+        if ((data & BlockLogicTrapDoor.MASK_UPPER_HALF) != 0) return this.top[color];
+        return this.bottom[color];
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericVeryRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericVeryRotatable.java
new file mode 100644
index 000000000..92148e825
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericVeryRotatable.java
@@ -0,0 +1,50 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicVeryRotatable;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericVeryRotatable<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public BlockModelGenericVeryRotatable(@NotNull Block<T> block, @NotNull StaticBlockModel staticModel) {
+        super(block, staticModel);
+    }
+
+    public BlockModelGenericVeryRotatable(@NotNull Block<T> block, @NotNull BlockModelData staticModel) {
+        super(block, staticModel);
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        final Direction dir = BlockLogicVeryRotatable.metaToDirection(worldSource.getBlockData(tilePos));
+        switch (dir) {
+            case UP -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case DOWN -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, -1, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case NORTH -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case SOUTH -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case WEST -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case EAST -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+        }
+        return false;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericWool.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericWool.java
new file mode 100644
index 000000000..2e6fc433b
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericWool.java
@@ -0,0 +1,31 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.util.helper.DyeColor;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericWool<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final StaticBlockModel[] models = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public BlockModelGenericWool(@NotNull Block<T> block, @NotNull StaticBlockModel staticModel) {
+        super(block, staticModel);
+        for (DyeColor c : DyeColor.blockOrderedColors()) {
+            this.models[c.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/wool/" + c.colorID).asModel();
+        }
+    }
+
+    public BlockModelGenericWool(@NotNull Block<T> block, @NotNull BlockModelData staticModel) {
+        super(block, staticModel);
+        for (DyeColor c : DyeColor.blockOrderedColors()) {
+            this.models[c.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/wool/" + c.colorID).asModel();
+        }
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return this.models[data & DyeColor.MASK_COLOR];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
index da5b77a44..96912b50d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
@@ -14,12 +14,11 @@ import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tileentity.TileEntityRenderer;
-import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.BlocksContainer;
 import net.minecraft.core.world.pos.TilePos;
@@ -110,7 +109,7 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player> {
 
     @Override
     protected void renderSpecials(final @NotNull TessellatorGeneral t, final @NotNull Player entity, final double x, final double y, final double z) {
-        if (Minecraft.getMinecraft().thePlayer.getGamemode() != Gamemode.spectator && entity.getGamemode() == Gamemode.spectator) {
+        if (Minecraft.getMinecraft().thePlayer.getGamemode() != Gamemodes.SPECTATOR && entity.getGamemode() == Gamemodes.SPECTATOR) {
             return;
         }
         if (Minecraft.getMinecraft().gameSettings.immersiveMode.drawNames() && this.renderDispatcher.camera != null) // Render name
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java
index eb328e0e7..fab038112 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java
@@ -175,6 +175,7 @@ public class TessellatorTerrainImpl implements TessellatorGeneral {
 
 	public void checkIsDrawing() {
 		if(!this.drawing) {
+			this.drawing = false;
 			throw new IllegalStateException("Not drawing!");
 		}
 	}
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
index f5fee0b2c..5092ad179 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
@@ -103,9 +103,9 @@ public class TextureRegistry {
         final int slashIndex = id.value().indexOf("/");
         String atlasId = id.value().substring(0, slashIndex);
         final AtlasStitcher atlas = stitcherMap.get(atlasId);
-        if (atlas == null) throw new IllegalArgumentException("Failed to find atlas '" + atlasId + "'!");
+        if (atlas == null) throw new IllegalArgumentException("Failed to find atlas '" + atlasId + "'! From ID: " + id);
 
-        return atlas.iconMap.containsKey(NamespaceID.fromPool(id.namespace(), id.value().substring(slashIndex + 1)));
+        return atlas.iconMap.containsKey(id);
     }
     public static @NotNull AtlasStitcher register(@NotNull AtlasStitcher atlas){
         for (String id : atlas.idDirMap.keySet()) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
index 74d1e7ac7..a897e1903 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
@@ -4,10 +4,11 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
-import net.minecraft.client.render.block.model.BlockModelPiston;
-import net.minecraft.client.render.block.model.BlockModelPistonHead;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericPiston;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericPistonHead;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
@@ -39,26 +40,20 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
             }
             TilePos tileEntPos = new TilePos(tileEntity.x, tileEntity.y, tileEntity.z);
             TextureRegistry.worldAtlas.bind();
-            Lighting.disable();
+            GLRenderer.setShader(Shaders.TERRAIN);
             GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
             GLRenderer.enableState(State.BLEND);
             GLRenderer.disableState(State.CULL_FACE);
             tessellator.startDrawingQuads();
             tessellator.setTranslation(((float) x - (float) tileEntity.x) + tileEntity.getXOff(partialTick), ((float) y - (float) tileEntity.y) + tileEntity.getYOff(partialTick), ((float) z - (float) tileEntity.z) + tileEntity.getZOff(partialTick));
             if (Block.hasLogicClass(block, BlockLogicPistonHead.class) && tileEntity.getProgress(partialTick) < 0.5F) {
-                ((BlockModelPistonHead) BlockModelDispatcher.getInstance().getDispatch(block)).renderPistonHeadNoCulling(tessellator, tileEntity.worldObj, (Block<BlockLogicPistonHead>) block, tileEntPos, false);
+                ((BlockModelGenericPistonHead<?>) BlockModelDispatcher.getInstance().getDispatch(block)).renderPistonHeadNoCulling(tessellator, tileEntity.worldObj, tileEntity.getBlockMeta(), tileEntPos, false);
             } else if (tileEntity.isSourcePiston() && !tileEntity.isExtending()) {
-                BlockModelPiston<?> pistonBase = (BlockModelPiston<?>) BlockModelDispatcher.getInstance().getDispatch(block);
+                BlockModelGenericPiston<?> pistonBase = (BlockModelGenericPiston<?>) BlockModelDispatcher.getInstance().getDispatch(block);
                 if (Block.hasLogicClass(block, BlockLogicPistonBaseSteel.class)) { // Todo remove this terrible hardcoded render code
-                    BlockModelPistonHead blockModelPistonHead = ((BlockModelPistonHead) BlockModelDispatcher.getInstance().getDispatch(Blocks.PISTON_HEAD_STEEL));
-                    blockModelPistonHead.setFaceTextureOverride(pistonBase.getFaceTexture());
-                    blockModelPistonHead.renderPistonHeadNoCulling(tessellator, tileEntity.worldObj, Blocks.PISTON_HEAD_STEEL, tileEntPos, tileEntity.getProgress(partialTick) < 0.5F);
-                    blockModelPistonHead.setFaceTextureOverride(null);
+                    ((BlockModelGenericPistonHead<?>) BlockModelDispatcher.getInstance().getDispatch(Blocks.PISTON_HEAD_STEEL)).renderPistonHeadNoCulling(tessellator, tileEntity.worldObj, BlockLogicPistonHead.TYPE_STEEL << 3, tileEntPos, tileEntity.getProgress(partialTick) < 0.5F);
                 } else {
-                    BlockModelPistonHead blockModelPistonHead = ((BlockModelPistonHead) BlockModelDispatcher.getInstance().getDispatch(Blocks.PISTON_HEAD));
-                    blockModelPistonHead.setFaceTextureOverride(pistonBase.getFaceTexture());
-                    blockModelPistonHead.renderPistonHeadNoCulling(tessellator, tileEntity.worldObj, Blocks.PISTON_HEAD, tileEntPos, tileEntity.getProgress(partialTick) < 0.5F);
-                    blockModelPistonHead.setFaceTextureOverride(null);
+                    ((BlockModelGenericPistonHead<?>) BlockModelDispatcher.getInstance().getDispatch(Blocks.PISTON_HEAD)).renderPistonHeadNoCulling(tessellator, tileEntity.worldObj, tileEntity.getBlockMeta(), tileEntPos, tileEntity.getProgress(partialTick) < 0.5F);
                 }
                 tessellator.setTranslation((float) x - (float) tileEntity.x, (float) y - (float) tileEntity.y, (float) z - (float) tileEntity.z);
                 pistonBase.renderHeadless(tessellator, tileEntity.worldObj, tileEntPos);
@@ -71,8 +66,6 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
             tessellator.setTranslation(0.0D, 0.0D, 0.0D);
             tessellator.draw();
 
-            Lighting.enableLight();
-
             TileEntity movedEntity = tileEntity.getMovedEntity();
             TileEntityRenderer<TileEntity> renderer = TileEntityRenderDispatcher.instance.getRenderer(movedEntity);
             if (renderer != null) {
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java b/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
index 85b158547..185e962b9 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
@@ -65,7 +65,7 @@ public class ItemDragHandler extends Gui {
                 this.renderItemStack = this.draggingItemStack.copy();
                 this.renderItemStack.stackSize = 1;
 
-				boolean isCreativeDragging = this.draggingButton == 2 && !this.mc.thePlayer.getGamemode().consumeBlocks();
+				boolean isCreativeDragging = this.draggingButton == 2 && !this.mc.thePlayer.getGamemode().hasBlockConsumption();
 				
 				if(isCreativeDragging) {
                     this.renderItemStackCount = this.draggingItemStack.getMaxStackSize();
@@ -91,7 +91,7 @@ public class ItemDragHandler extends Gui {
 	private void onDragOverSlot(Slot slot) {
 		if(slot == null) return;
 		
-		boolean isCreativeDragging = this.draggingButton == 2 && !this.mc.thePlayer.getGamemode().consumeBlocks();
+		boolean isCreativeDragging = this.draggingButton == 2 && !this.mc.thePlayer.getGamemode().hasBlockConsumption();
 		if(this.draggedSlots.size() >= this.draggingItemStack.stackSize && !isCreativeDragging) {
 			return;
 		}
@@ -244,7 +244,7 @@ public class ItemDragHandler extends Gui {
 		
 		InventoryAction action = mode == 1 ? InventoryAction.DRAG_ITEMS_ONE : InventoryAction.DRAG_ITEMS_ALL;
 		
-		if(mode == 2 && !this.mc.thePlayer.getGamemode().consumeBlocks()) {
+		if(mode == 2 && !this.mc.thePlayer.getGamemode().hasBlockConsumption()) {
 			action = InventoryAction.CREATIVE_DRAG;
 		}
 		
